require "util"
require "defines"
require "story"

-- localisation shortcut

game.on_init(function()
  game.map_settings.enemy_expansion.enabled = false
  game.evolution_factor = 0
  game.map_settings.enemy_evolution.enabled = false
  game.forces.enemy.set_turret_attack_modifier('laser-turret',-0.6) 
  --getting surface
  for _,sur in pairs(game.surfaces) do
    surf=sur
  end
  for _,turret in pairs(surf.find_entities_filtered{area={{-500,-380},{500,500}},type='electric-turret'}) do
    turret.force=game.forces.enemy
  end
  for _,gate in pairs(surf.find_entities_filtered{area={{-500,-400},{500,500}},name='diesel-locomotive'}) do
    gate.force=game.forces.player
  end
  for _,mine in pairs(surf.find_entities_filtered{area={{404,-175},{445,-162}},type='land-mine'}) do
    mine.force=game.forces.enemy
  end
  for _,mine in pairs(surf.find_entities_filtered{area={{404,-175},{445,-162}},type='wall'}) do
    mine.force=game.forces.enemy
  end

  local recipelist = game.player.force.recipes
  recipelist["science-pack-3"].enabled = false

  local techlist = game.player.force.technologies
  techlist["logistics-3"].enabled = false
  techlist["speed-module-2"].enabled = false
  techlist["speed-module-3"].enabled = false
  techlist["effectivity-module-2"].enabled = false
  techlist["effectivity-module-3"].enabled = false
  techlist["productivity-module-2"].enabled = false
  techlist["productivity-module-3"].enabled = false
  techlist["laser-turret-damage-3"].enabled = false
  techlist["laser-turret-speed-3"].enabled = false
  --techlist["armor-making"].enabled = false
  --techlist["armor-making-2"].enabled = false
  techlist["railway"].enabled = false
  techlist["automated-rail-transportation"].enabled = false
  techlist["rail-signals"].enabled = false
  
  techlist["optics"].researched = true
  techlist["logistics"].researched = true
  techlist["automation"].researched = true
  techlist["logistic-robot-speed-1"].researched = true
  techlist["logistic-robot-speed-2"].researched = true
  techlist["logistic-robot-speed-3"].researched = true
  techlist["logistic-robot-storage-1"].researched = true
  techlist["follower-robot-count-1"].researched = true
  techlist["combat-robot-damage-1"].researched = true

  local character = game.player.character
  --character.insert{name = "steel-axe", count = 1}
  character.selected_gun_index = 1

  game.map_settings.pollution.enabled = false
  monitored_turret=game.get_surface(1).find_entity('laser-turret',{-142.5, -313.5})
end)

storytable =
{
  {
	--Mission 1
	{
		action=
		function()
			game.show_message_dialog{text={"prolog-1"}}
			game.show_message_dialog{text={"prolog-2"}}
			game.show_message_dialog{text={"prolog-3"}}
			game.show_message_dialog{text={"prolog-4"}}
			game.show_message_dialog{text={"prolog-5"}}
			game.show_message_dialog{text={"prolog-6"}}
			game.show_message_dialog{text={"prolog-7"}}
			game.show_message_dialog{text={"prolog-8"}}
			game.show_message_dialog{text={"prolog-9"}}
			game.show_message_dialog{text={"prolog-10"}}
			game.show_message_dialog{text={"prolog-11"}}
			game.show_message_dialog{text={"prolog-12"}}
			game.show_message_dialog{text={"prolog-13"}}
		end
	},
    {
      condition = story.Story:elapsedcheck(0),
      action =
      function()
        game.player.print{"mission-1-1"}
      end
    },
	{
      condition = story.Story:elapsedcheck(1),
      action =
      function()
        game.player.print{"mission-1-2"}
		game.player.set_goal_description{"mission-1-Ziel"}
      end
    },
	{
      condition = story.Story:elapsedcheck(1),
      action =
      function()
        game.player.print{"mission-1-3"}
      end
    },
	{
      condition =
      function()
        local wrack = game.get_entity_by_tag("wrack")
        return game.get_entity_by_tag("wrack")==(game.player.opened) or 
			not wrack.has_items_inside()
	  end
    },
	{
      condition = story.Story:elapsedcheck(2),
      action =
      function()
        game.show_message_dialog{text={"computer-weg-1"}}
		game.show_message_dialog{text={"computer-weg-2"}}
      end
    },
	--Mission 1 - Geschützturm
	{
      condition = 
	  function()
		return (game.player.position.x > -5) and (game.player.position.x < 10) and (game.player.position.y > 300) and (game.player.position.y < 350)
	  end,
      action =
      function()
		game.show_message_dialog{text={"mission-1-4"}}
		game.show_message_dialog{text={"mission-1-5"}}
      end
    },
	--Mission 1 - Festung
	{
      condition = 
	  function()
		return (game.player.position.x > 110) and (game.player.position.x < 120) and (game.player.position.y > 277) and (game.player.position.y < 327)
	  end,
      action =
      function()
		game.show_message_dialog{text={"mission-1-6"}}
		game.show_message_dialog{text={"mission-1-7"}}
        game.show_message_dialog{text={"mission-1-8"}}
		game.player.set_goal_description{"mission-1-Ziel-2"}
      end
    },
	--Mission 1 - Sieg - Mission 2
    {
      condition = 
	  function()
		return (game.player.position.x > 155) and (game.player.position.x < 164) and (game.player.position.y > 295) and (game.player.position.y < 304)
	  end,
      action =
      function()
        game.show_message_dialog{text={"mission-1-9"}}
		game.show_message_dialog{text={"mission-1-10"}}
		game.show_message_dialog{text={"mission-1-11"}}
		game.player.set_goal_description{"mission-2-Ziel"}
      end
    },
	--Mission 2 - Beisserinsel betreten
    {
      condition = 
	  function()
		return (game.player.position.x > 233) and (game.player.position.x < 250) and (game.player.position.y > 294) and (game.player.position.y < 320)
	  end,
      action =
      function()
	  game.show_message_dialog{text={"mission-2-1"}}
	  game.show_message_dialog{text={"mission-2-2"}}
      end
    },
	--Mission 2 - "Militär" erforschen
	{
	  condition = function() return game.player.force.technologies["military"].researched end,
	  action =
      function()
		game.show_message_dialog{text={"mission-2-3"}}
		game.show_message_dialog{text={"mission-2-4"}}
		game.player.set_goal_description("")
      end
	},
	--Mission 3
	{
	  condition = story.Story:elapsedcheck(8),
	  action =
      function()
		game.player.set_goal_description{"mission-3-Ziel"}
		game.show_message_dialog{text={"mission-3-1"}}
		game.show_message_dialog{text={"mission-3-2"}}
		game.show_message_dialog{text={"mission-3-3"}}
      end
	},
	{
	  condition = story.Story:elapsedcheck(10),
	  action =
      function()
		game.player.print{"mission-3-4"}
      end
	},
	--Mission 3 - Zweite Festung
	{
	  condition = 
	  function()
		return (game.player.position.x > 310) and (game.player.position.x < 364) and (game.player.position.y > 175) and (game.player.position.y < 198)
	  end,
	  action =
      function()
		game.player.print{"mission-3-5"}
      end
	},
	{
	  condition = story.Story:elapsedcheck(4),
	  action =
      function()
		game.player.print{"mission-3-6"}
      end
	},
	--Mission 3 - Vorgeschobene Festung
	{
	  condition = 
	  function()
		return (game.player.position.x > 385) and (game.player.position.x < 446) and (game.player.position.y > -57) and (game.player.position.y < -30)
	  end,
	  action =
      function()
		game.show_message_dialog{text={"mission-3-7"}}
		game.show_message_dialog{text={"mission-3-8"}}
		game.show_message_dialog{text={"mission-3-9"}}
      end
	},
	--Mission 3 - Uneinnehmbare Festung - Mission 4
	{
	  condition = 
	  function()
		return (game.player.position.x > 402) and (game.player.position.x < 440) and (game.player.position.y > -155) and (game.player.position.y < -140)
	  end,
	  action =
      function()
	  game.player.set_goal_description("")
		game.show_message_dialog{text={"mission-3-10"}}
		game.show_message_dialog{text={"mission-3-11"}}
		game.show_message_dialog{text={"mission-3-12"}}
		game.player.set_goal_description{"mission-4-Ziel"}
      end
	},
	--Mission 4 - Leitung kappen
	{
	  condition = 
	  function()
		return (game.player.position.x < 402) and (game.player.position.x > 390) and (game.player.position.y > -160) and (game.player.position.y < -147)
	  end,
	  action =
      function()
		game.show_message_dialog{text={"mission-4-1"}}
		game.show_message_dialog{text={"mission-4-2"}}
      end
	},
	--Mission 4 - Vorgeschobene Festung plündern
	{
	  condition = function() return game.player.get_item_count("fusion-reactor-equipment") > 0 end,
	  action =
      function()
		game.show_message_dialog{text={"mission-4-3"}}
      end
	},
	--Mission 4 - Zweite Festung plündern
	{
	  condition = function() return game.player.get_item_count("energy-shield-mk2-equipment") > 0 end,
	  action =
      function()
		game.show_message_dialog{text={"mission-4-4"}}
		game.show_message_dialog{text={"mission-4-5"}}
		game.show_message_dialog{text={"mission-4-6"}}
      end
	},
	--Mission 4 - Anderes Stadttor erreichen - Mission 5
	{
	  condition = 
	  function()
		return (game.player.position.x > -70) and (game.player.position.x < -20) and (game.player.position.y > -145) and (game.player.position.y < -130)
	  end,
	  action =
      function()
		game.show_message_dialog{text={"mission-4-7"}}
		game.show_message_dialog{text={"mission-4-8"}}
		game.show_message_dialog{text={"mission-4-9"}}
		game.show_message_dialog{text={"mission-4-10"}}
		game.player.set_goal_description{"mission-5-Ziel"}
      end
	},
	--Mission 5 - Ebene erreichen
	{
	  condition = 
	  function()
		return (game.player.position.x > -212) and (game.player.position.x < -195) and (game.player.position.y > -170) and (game.player.position.y < -120)
	  end,
	  action =
      function()
		game.show_message_dialog{text={"mission-5-1"}}
		game.show_message_dialog{text={"mission-5-2"}}
		game.show_message_dialog{text={"mission-5-3"}}
		game.show_message_dialog{text={"mission-5-4"}}
		game.show_message_dialog{text={"mission-5-5"}}
      end
	},
	{
	  condition = story.Story:elapsedcheck(8),
	  action =
      function()
		game.show_message_dialog{text={"mission-5-6"}}
		game.show_message_dialog{text={"mission-5-7"}}
		game.show_message_dialog{text={"mission-5-8"}}
		game.show_message_dialog{text={"mission-5-9"}}
		game.show_message_dialog{text={"mission-5-10"}}
		game.show_message_dialog{text={"mission-5-11"}}
      end
	},
	--Mission 5 - Energiezentrale zerstört
	{
	  condition = 
	  function()
		return (game.player.position.x > -477) and (game.player.position.x < -449) and (game.player.position.y > -257) and (game.player.position.y < -207)
	  end,
	  action =
      function()
		game.player.set_goal_description("")
		game.show_message_dialog{text={"mission-5-12"}}
      end
	},
    {
        condition=function() return monitored_turret.energy<600000; end,
        action= function() game.show_message_dialog{text={"mission-5-13"}}; end
    },
	--Mission 6
	{
	  condition = 
        function()
            return (game.player.position.x > -60) and (game.player.position.x < -27) and (game.player.position.y > -142) and (game.player.position.y < -139)
        end,
	  action =
      function()
		game.player.set_goal_description{"mission-6-Ziel"}
		game.show_message_dialog{text={"mission-6-1"}}
		game.show_message_dialog{text={"mission-6-2"}}
      end
	},
	--Mission 6 - Killertürme zerstört
	{
	  condition = 
	  function()
		return (game.player.position.x > -57) and (game.player.position.x < -36) and (game.player.position.y > -170) and (game.player.position.y < -162)
	  end,
	  action =
      function()
		game.show_message_dialog{text={"mission-6-3"}}
		game.show_message_dialog{text={"mission-6-4"}}
      end
	},
	--Mission 6 - Stadttore erreichen
	{
	  condition = 
	  function()
		return (game.player.position.x > -95) and (game.player.position.x < -63) and (game.player.position.y > -390) and (game.player.position.y < -374)
	  end,
	  action =
      function()
		game.player.set_goal_description("")
		game.show_message_dialog{text={"epilog-1"}}
		game.show_message_dialog{text={"epilog-2"}}
		game.show_message_dialog{text={"epilog-3"}}
		game.show_message_dialog{text={"epilog-4"}}
		game.show_message_dialog{text={"epilog-5"}}
		game.show_message_dialog{text={"epilog-6"}}
		game.show_message_dialog{text={"epilog-7"}}
		game.show_message_dialog{text={"epilog-8"}}
		game.show_message_dialog{text={"epilog-9"}}
		game.show_message_dialog{text={"epilog-10"}}
		game.show_message_dialog{text={"epilog-11"}}
		game.show_message_dialog{text={"epilog-12"}}
		game.show_message_dialog{text={"epilog-13"}}
		game.show_message_dialog{text={"epilog-14"}}
      end
	},
	{
	  condition = story.Story:elapsedcheck(4),
	  action =
      function()
		game.show_message_dialog{text={"ende-1"}}
		game.show_message_dialog{text={"ende-2"}}
		game.show_message_dialog{text={"ende-3"}}
      end
	}
  }
}

mainstory = story.Story:new(storytable)

--function onwin()
--		game.getplayer().setendingscreendata(gt("ende"), "thecity-theme.png")
--	end
	
game.on_save(function()
  global.storydata = mainstory:export()
end)

game.on_load(function()
  mainstory:import(global.storydata)
end)

game.on_event(defines.events, function(event)
  mainstory:update(event, "", onwin)
end)
